#include <konkret/konkret.h>
#include "ElementConformsToProfile.h"
#include "Resource.h"

static const CMPIBroker* _cb;

static void ElementConformsToProfileInitialize()
{
}

static CMPIStatus ElementConformsToProfileCleanup( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ElementConformsToProfileEnumInstanceNames( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus ElementConformsToProfileEnumInstances( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    const char* ns = INTEROP_NAMESPACE;
    RegisteredProfileRef cs;

    /* Linux_SSHRegisteredProfile.ConformantStandard */
    RegisteredProfileRef_Init(&cs, _cb, ns);
    RegisteredProfileRef_Set_InstanceID(&cs, "SBLIM:SSH_Service");

    /* Associate with every instance of Linux_SSHProtocolService */
    return KDefaultEnumerateInstancesOneToAll(
        _cb,
        cc,
        cr,
        cop,
        RegisteredProfileRef_ToObjectPath(&cs, NULL),
        "ConformantStandard",
        CMNewObjectPath(_cb, NAMESPACE, "Linux_SSHProtocolService", NULL),
        "ManagedElement");
}

static CMPIStatus ElementConformsToProfileGetInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc,
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus ElementConformsToProfileCreateInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const CMPIInstance* ci) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ElementConformsToProfileModifyInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop,
    const CMPIInstance* ci, 
    const char**properties) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ElementConformsToProfileDeleteInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ElementConformsToProfileExecQuery(
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char* lang, 
    const char* query) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ElementConformsToProfileAssociationCleanup( 
    CMPIAssociationMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term) 
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ElementConformsToProfileAssociators(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole,
    const char** properties)
{
    return KDefaultAssociators(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ElementConformsToProfile_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole,
        properties);
}

static CMPIStatus ElementConformsToProfileAssociatorNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole)
{
    return KDefaultAssociatorNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ElementConformsToProfile_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole);
}

static CMPIStatus ElementConformsToProfileReferences(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role,
    const char** properties)
{
    return KDefaultReferences(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ElementConformsToProfile_ClassName,
        assocClass,
        role,
        properties);
}

static CMPIStatus ElementConformsToProfileReferenceNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role)
{
    return KDefaultReferenceNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ElementConformsToProfile_ClassName,
        assocClass,
        role);
}

CMInstanceMIStub( 
    ElementConformsToProfile,
    Linux_SSHElementConformsToProfile,
    _cb,
    ElementConformsToProfileInitialize())

CMAssociationMIStub( 
    ElementConformsToProfile,
    Linux_SSHElementConformsToProfile,
    _cb,
    ElementConformsToProfileInitialize())

KONKRET_REGISTRATION(
    "root/cimv2 root/interop",
    "Linux_SSHElementConformsToProfile",
    "Linux_SSHElementConformsToProfile",
    "instance association");
