#include <konkret/konkret.h>
#include "HostedAccessPoint.h"
#include "Resource.h"

static const CMPIBroker* _cb;

static void HostedAccessPointInitialize()
{
}

static CMPIStatus HostedAccessPointCleanup( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus HostedAccessPointEnumInstanceNames( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus HostedAccessPointEnumInstances( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    ComputerSystemRef a; /* Antecedent */
    Str256 s;

    ComputerSystemRef_Init(&a, _cb, KNameSpace(cop));
    ComputerSystemRef_Set_CreationClassName(&a, "Linux_ComputerSystem");
    ComputerSystemRef_Set_Name(&a, SysName(&s));

    return KDefaultEnumerateInstancesOneToAll(
        _cb, 
        cc,
        cr,
        cop,
        ComputerSystemRef_ToObjectPath(&a, NULL),
        "Antecedent",
        CMNewObjectPath(_cb, KNameSpace(cop), "Linux_SSHProtocolEndpoint",NULL),
        "Dependent");
}

static CMPIStatus HostedAccessPointGetInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc,
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus HostedAccessPointCreateInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const CMPIInstance* ci) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus HostedAccessPointModifyInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop,
    const CMPIInstance* ci, 
    const char**properties) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus HostedAccessPointDeleteInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus HostedAccessPointExecQuery(
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char* lang, 
    const char* query) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus HostedAccessPointAssociationCleanup( 
    CMPIAssociationMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term) 
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus HostedAccessPointAssociators(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole,
    const char** properties)
{
    return KDefaultAssociators(
        _cb,
        mi,
        cc,
        cr,
        cop,
        HostedAccessPoint_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole,
        properties);
}

static CMPIStatus HostedAccessPointAssociatorNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole)
{
    return KDefaultAssociatorNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        HostedAccessPoint_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole);
}

static CMPIStatus HostedAccessPointReferences(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role,
    const char** properties)
{
    return KDefaultReferences(
        _cb,
        mi,
        cc,
        cr,
        cop,
        HostedAccessPoint_ClassName,
        assocClass,
        role,
        properties);
}

static CMPIStatus HostedAccessPointReferenceNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role)
{
    return KDefaultReferenceNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        HostedAccessPoint_ClassName,
        assocClass,
        role);
}

CMInstanceMIStub( 
    HostedAccessPoint,
    Linux_SSHHostedAccessPoint,
    _cb,
    HostedAccessPointInitialize())

CMAssociationMIStub( 
    HostedAccessPoint,
    Linux_SSHHostedAccessPoint,
    _cb,
    HostedAccessPointInitialize())

KONKRET_REGISTRATION(
    "root/cimv2",
    "Linux_SSHHostedAccessPoint",
    "Linux_SSHHostedAccessPoint",
    "instance association")
