#include <konkret/konkret.h>
#include "ProvidesEndpoint.h"
#include "Resource.h"

static const CMPIBroker* _cb;

static void ProvidesEndpointInitialize()
{
}

static CMPIStatus ProvidesEndpointCleanup( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ProvidesEndpointEnumInstanceNames( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus ProvidesEndpointEnumInstances( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    const char* ns = KNameSpace(cop);
    ProtocolServiceRef a; /* Antecedent */
    Str256 s;

    /* Linux_SSHProtocolService.Antecedent */
    ProtocolServiceRef_Init(&a, _cb, ns);
    ProtocolServiceRef_Set_SystemCreationClassName(&a, SysClassName(&s));
    ProtocolServiceRef_Set_CreationClassName(&a, "Linux_SSHProtocolService");
    ProtocolServiceRef_Set_SystemName(&a, SysName(&s));
    ProtocolServiceRef_Set_Name(&a, "SBLIM:Linux_SSHProtocolService");

    /* Associate with every instance of Linux_SSHProtocolEndpoint */
    return KDefaultEnumerateInstancesOneToAll(
        _cb,
        cc,
        cr,
        cop,
        ProtocolServiceRef_ToObjectPath(&a, NULL),
        "Antecedent",
        CMNewObjectPath(_cb, ns, "Linux_SSHProtocolEndpoint", NULL),
        "Dependent");
}

static CMPIStatus ProvidesEndpointGetInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc,
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus ProvidesEndpointCreateInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const CMPIInstance* ci) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ProvidesEndpointModifyInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop,
    const CMPIInstance* ci, 
    const char**properties) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ProvidesEndpointDeleteInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ProvidesEndpointExecQuery(
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char* lang, 
    const char* query) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ProvidesEndpointAssociationCleanup( 
    CMPIAssociationMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term) 
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ProvidesEndpointAssociators(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole,
    const char** properties)
{
    return KDefaultAssociators(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ProvidesEndpoint_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole,
        properties);
}

static CMPIStatus ProvidesEndpointAssociatorNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole)
{
    return KDefaultAssociatorNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ProvidesEndpoint_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole);
}

static CMPIStatus ProvidesEndpointReferences(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role,
    const char** properties)
{
    return KDefaultReferences(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ProvidesEndpoint_ClassName,
        assocClass,
        role,
        properties);
}

static CMPIStatus ProvidesEndpointReferenceNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role)
{
    return KDefaultReferenceNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ProvidesEndpoint_ClassName,
        assocClass,
        role);
}

CMInstanceMIStub( 
    ProvidesEndpoint,
    Linux_SSHProvidesEndpoint,
    _cb,
    ProvidesEndpointInitialize())

CMAssociationMIStub( 
    ProvidesEndpoint,
    Linux_SSHProvidesEndpoint,
    _cb,
    ProvidesEndpointInitialize())

KONKRET_REGISTRATION(
    "root/cimv2",
    "Linux_SSHProvidesEndpoint",
    "Linux_SSHProvidesEndpoint",
    "instance association")
