#include <konkret/konkret.h>
#include "ReferencedProfile.h"

static const CMPIBroker* _cb;

static void ReferencedProfileInitialize()
{
}

static CMPIStatus ReferencedProfileCleanup( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ReferencedProfileEnumInstanceNames( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus ReferencedProfileEnumInstances( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    const char* ns = KNameSpace(cop);
    ReferencedProfile x;
    CIM_RegisteredProfileRef a;
    RegisteredProfileRef d;
    
    /* Linux_RegisteredProfileComputerSystem.Antecedent */
    CIM_RegisteredProfileRef_Init(&a, _cb, ns);
    CIM_RegisteredProfileRef_Set_InstanceID(&a,"SBLIM:Base_Computer");
    
    /* Linux_SSHRegisteredProfile.Dependent */
    RegisteredProfileRef_Init(&d, _cb, ns);
    RegisteredProfileRef_Set_InstanceID(&d, "SBLIM:SSH_Service");
    
    /* Linux_FanReferencedProfile */
    ReferencedProfile_Init(&x, _cb, ns);
    ReferencedProfile_Set_Antecedent(&x, &a);
    ReferencedProfile_Set_Dependent(&x, &d);
    
    /* Return instance */
    KReturnInstance(cr, x);
    
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ReferencedProfileGetInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc,
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus ReferencedProfileCreateInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const CMPIInstance* ci) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ReferencedProfileModifyInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop,
    const CMPIInstance* ci, 
    const char**properties) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ReferencedProfileDeleteInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ReferencedProfileExecQuery(
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char* lang, 
    const char* query) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus ReferencedProfileAssociationCleanup( 
    CMPIAssociationMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term) 
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus ReferencedProfileAssociators(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole,
    const char** properties)
{
    return KDefaultAssociators(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ReferencedProfile_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole,
        properties);
}

static CMPIStatus ReferencedProfileAssociatorNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole)
{
    return KDefaultAssociatorNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ReferencedProfile_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole);
}

static CMPIStatus ReferencedProfileReferences(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role,
    const char** properties)
{
    return KDefaultReferences(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ReferencedProfile_ClassName,
        assocClass,
        role,
        properties);
}

static CMPIStatus ReferencedProfileReferenceNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role)
{
    return KDefaultReferenceNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        ReferencedProfile_ClassName,
        assocClass,
        role);
}

CMInstanceMIStub( 
    ReferencedProfile,
    Linux_SSHReferencedProfile,
    _cb,
    ReferencedProfileInitialize())

CMAssociationMIStub( 
    ReferencedProfile,
    Linux_SSHReferencedProfile,
    _cb,
    ReferencedProfileInitialize())

KONKRET_REGISTRATION(
    "root/interop",
    "Linux_SSHReferencedProfile",
    "Linux_SSHReferencedProfile",
    "instance association");
