#include <konkret/konkret.h>
#include "RegisteredProfile.h"

static const CMPIBroker* _cb = NULL;

static void RegisteredProfileInitialize()
{
}

static CMPIStatus RegisteredProfileCleanup(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus RegisteredProfileEnumInstanceNames(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus RegisteredProfileEnumInstances(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    RegisteredProfile x;

    RegisteredProfile_Init(&x, _cb, KNameSpace(cop));
    RegisteredProfile_Set_InstanceID(&x, "SBLIM:SSH_Service");
    RegisteredProfile_Set_RegisteredOrganization_DMTF(&x);
    RegisteredProfile_Set_RegisteredName(&x, "SSH Service");
    RegisteredProfile_Set_RegisteredVersion(&x, "1.0");
    RegisteredProfile_Init_AdvertiseTypes(&x, 1);
    RegisteredProfile_Set_AdvertiseTypes_SLP(&x, 0);
    KReturnInstance(cr, x);

    CMReturn(CMPI_RC_OK);
}

static CMPIStatus RegisteredProfileGetInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus RegisteredProfileCreateInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus RegisteredProfileModifyInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci,
    const char** properties)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus RegisteredProfileDeleteInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus RegisteredProfileExecQuery(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* lang,
    const char* query)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

CMInstanceMIStub(
    RegisteredProfile,
    Linux_SSHRegisteredProfile,
    _cb,
    RegisteredProfileInitialize())

static CMPIStatus RegisteredProfileMethodCleanup(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus RegisteredProfileInvokeMethod(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* meth,
    const CMPIArgs* in,
    CMPIArgs* out)
{
    return RegisteredProfile_DispatchMethod(
        _cb, mi, cc, cr, cop, meth, in, out);
}

CMMethodMIStub(
    RegisteredProfile,
    Linux_SSHRegisteredProfile,
    _cb,
    RegisteredProfileInitialize())

KONKRET_REGISTRATION(
    "root/interop",
    "Linux_SSHRegisteredProfile",
    "Linux_SSHRegisteredProfile",
    "instance method");
