#ifndef _Resource_h
#define _Resource_h

#include <konkret/konkret.h>
#include <cmpiutil/base.h>
#include <cmpiutil/exec.h>

#ifndef KONKRET_REGISTRATION
# define KONKRET_REGISTRATION(W,X,Y,Z) /* empty */
#endif

#define HIDDEN __attribute__((visibility("hidden")))

#define NAMESPACE "root/cimv2"
#define INTEROP_NAMESPACE "root/interop"

/* Returns 0 if sshd service is running */
HIDDEN int GetSSHDStatus();

struct SSHDConfig
{
    /* non-zero (1) if sshd supports protocol version 1 */
    int v1;

    /* non-zero (1) if sshd supports protocol version 2 */
    int v2;

    /* non-zero (1) if sshd TCPKeepAlive option is yes */
    int tcpKeepAlive;

    /* non-zero (1) if sshd ForwardX11 option is yes */
    int x11Forwarding;

    /* Compression option: 'y' (yes), 'n' (no), or 'd' (delayed) */
    char compression;

    /* ClientAliveInterval option: seconds between sends (0 = never send) */
    int clientAliveInterval;
};

HIDDEN int GetSSHDConfig(struct SSHDConfig* conf);

struct SSHSession
{
    char localAddr[64];
    unsigned short localPort;
    char foreignAddr[64];
    unsigned short foreignPort;
    unsigned int pid;
    char user[64];
};

HIDDEN int GetSSHSessions(
    struct SSHSession** sessions,
    size_t* num_sessions);

typedef struct _Str256
{
    char buf[256];
}
Str256;

KINLINE char* SysName(Str256* s)
{
    s->buf[0] = '\0';
    cmpiutilGetComputerSystemName(s->buf, sizeof(s->buf)-1);
    return s->buf;
}

KINLINE char* SysClassName(Str256* s)
{
    s->buf[0] = '\0';
    strncat(s->buf, cmpiutilGetComputerSystemClassName(), sizeof(s->buf)-1);
    return s->buf;
}

KINLINE char* SysCreationClassName(Str256* s)
{
    s->buf[0] = '\0';
    strncat(s->buf, "Linux_ComputerSystem", sizeof(s->buf)-1);
    return s->buf;
}

#endif /* _Resource_h */
